//*****************************************
// Six IN-17 Clock2 Program ATmega64(64pin)
// CPU Clock:8MHz
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:ad_conv.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//*****************************************
#include				<avr/io.h>

#include	"mega48_8x8_dot.h"
#include	"ad_conv.h"

static	int				ad6_data[N_of_AD_data];
int						ad6_ave;
static	unsigned char	ad6_count;

static	int				ad7_data[N_of_AD_data];
int						ad7_ave;
static	unsigned char	ad7_count;

unsigned char	ad_conv_67;									// 0:ADC6 Convert Running, 1:ADC7 Convert running
// **********************************************************
// ************************* A/D 6,7 ************************
// **********************************************************

//*****************************************
// A/D 6,7 Initial
// @荞ݕs̏ԂŌĂ΂Ƃ
//*****************************************
void	ad67_init(void)
{
	unsigned char	i;

	ad6_count = 0;
	ad7_count = 0;
	for(i = 0; i < N_of_AD_data; i++){
		ad6_data[i] = 0;
		ad7_data[i] = 0;
	}
	ad6_ave = 0;
	ad7_ave = 0;


	ADMUX = ( (0 << REFS1) | (1 << REFS0) | (1 << MUX2) | (1 << MUX1) | (0 << MUX0) );		// `ubbdgp, EASelect ADC6
	ADCSRA = ( (1 << ADEN) | (1 << ADSC) | (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0) );	// A/D, A/DϊJn, CK/128=8MHz/128=62.5kHz(16uS) --> 208uS
	ad_conv_67 = 0;																			// 0:ADC6 Convert running

}
//*****************************************
// A/D 6,7 close
//*****************************************
void	ad67_close(void)
{
	ADCSRA = 0;																				// A/Ds
	ad_conv_67 = 0;																			// 0:ADC67 Convert Not running
}
//*****************************************
// A/D 6,7 Set A/D data to Data Buffer
//  ϊIĂȂ́@Ȃ
//*****************************************
void	ad67_set_data(void)
{
	if( (ADCSRA & (1 << ADIF)) != 0){								// `^cϊ
		ADCSRA |= (1 << ADIF);										// `^cϊtO폜
		if( ad_conv_67 == 0){										// ADC6 ϊ
			ad6_data[ad6_count] = ADCW;
			ad6_count++;
			ad6_count &= (N_of_AD_data - 1);
			ADMUX &= ( (1 << REFS1) | (1 << REFS0) );				// dwrbg͎c
			ADMUX |= ( (1 << MUX2) | (1 << MUX1) | (1 << MUX0) );	// Select ADC7
			ad_conv_67 = 1;											// 1:ADC7 Convert Running
		}else{														// ADC7 ϊ
			ad7_data[ad7_count] = ADCW;
			ad7_count++;
			ad7_count &= (N_of_AD_data - 1);
			ADMUX &= ( (1 << REFS1) | (1 << REFS0) );				// dwrbg͎c
			ADMUX |= ( (1 << MUX2) | (1 << MUX1) | (0 << MUX0) );	// Select ADC6
			ad_conv_67 = 0;											// 0:ADC0 Convert Running
		}

		ADCSRA |= (1 << ADSC);										// A/DϊJn
	}
}
//*****************************************
// A/D 7 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//*****************************************
unsigned int	ad7_get_data(void)
{
	unsigned char	i;
	unsigned int	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad7_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}
//*****************************************
// A/D 6 Get A/D data
//  obt@ɓĂf[^𕽋ςĎ擾
//*****************************************
unsigned int	ad6_get_data(void)
{
	unsigned char	i;
	unsigned int	sum;

	sum = 0;
	for(i = 0; i < N_of_AD_data; i++){						// obt@Sđ
		sum += ad6_data[i];
	}

	sum /= N_of_AD_data;									// f[^Ŋĕϒlɂ

	return(sum);
}

