//*****************************************
// Six IN-17 Clock2 Program ATmega64(64pin)
// CPU Clock:8MHz
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:eep_dat.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"mega48_8x8_dot.h"
#include	"port_bit.h"
#include	"timer.h"
#include	"uart.h"
#include	"eep_dat.h"

unsigned char	eep_char_bps EEMEM = 'E';		// ʐMaorw肷镶(A:600 B:1200, C:2400, D:4800, E:9600)
unsigned char	eep_delimiter EEMEM = 0x0d;		// ʐMf~^@bq(0x0d) or ke(0x0a)
unsigned char	eep_target_no EEMEM = 0;		// Ԗڂ̕\邩̔ԍ
static	unsigned char	eep_bfs[10];

//*****************************************
//@ddoqnl BPS CHAR ǂݍ
//*****************************************
unsigned char	read_eep_char_bps(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_char_bps);		// Ǐo
	if(('A' <= eep_bfs[0])&&(eep_bfs[0] <= 'E')){
		r = eep_bfs[0];
	}else{
		r = 'E';
	}

	return(r);
}

//*****************************************
//@ddoqnl BPS CHAR 
//*****************************************
void	write_eep_char_bps(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_char_bps, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
//*****************************************
//@ddoqnl ʐMf~^ ǂݍ
//*****************************************
unsigned char	read_eep_delimiter(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_delimiter);		// Ǐo
	if((0x0a == eep_bfs[0])||(eep_bfs[0] == 0x0d)){
		r = eep_bfs[0];
	}else{
		r = 0x0d;
	}

	return(r);
}

//*****************************************
//@ddoqnl ʐMf~^ 
//*****************************************
void	write_eep_delimiter(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_delimiter, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
//*****************************************
//@ddoqnl \Ԗ ǂݍ
//*****************************************
unsigned char	read_eep_target_no(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_target_no);		// Ǐo
	if(('0' <= eep_bfs[0])&&(eep_bfs[0] <= '9')){
		r = eep_bfs[0];
	}else{
		r = '0';
	}

	return(r);
}

//*****************************************
//@ddoqnl \Ԗ 
//*****************************************
void	write_eep_target_no(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_target_no, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
#if	0
//***************************
// ␳aorUOOvZ
// uc : ^C}[P̃JE^[lłWlgȂ΂VWPR̔
// ␳lVWPRaorQUOO
//***************************
static
unsigned short calcu_bps600(unsigned short us)
{
	unsigned short r;
	unsigned long ul;

	ul = us;
	ul *= (unsigned long)(BPS_600);
	ul /= (unsigned long)7813;
	r = (unsigned short)ul;

	return(r);

}

//***************************
// aorUOO̒lC
//  kdcSx_ł
//  XCb`ėꂽ 
//@^C}[P̒lŏʂɂS\BiWlg҂ȂVWPRj
//@aorUOO̒lŉʂRɕ\BiWlg҂ȂWRRj
//@qsb̂PbM̃^C~OŃ^C}[P̒lƂaorUOO̒lXV
//  rdsXCb`ꂽ@݂̂aorUOO̒lɏ݈Ȍケ̒lg
//***************************
static
void	edit_bps600(void)
{
	unsigned short	us;
	unsigned short	t1_count = 7813;
	unsigned short	bps600 = 833;
	unsigned char	old_rtc_1s_flg=0xff;

	bps600 = gBPS1_600;

	get_sw();

	timer1_init();									// Timer1 Initial
	tim_10ms_blink = 0;								// uNp^C}[𗬗p
	sei();											// 荞݉
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay
	get_sw();
	delay_ms(10);									// 10mS Delay

//	bef1_ad_ave = 0;
	led_ds2_off();									// LED(DS2) OFF
	tim_10ms_ad = 0;
	disp_dynamic_nixie_clear();						// Nixie \SAR
	disp_nixie_4binary(2,bps600);					// S\iXXXX܂Łj
	dynamic_nixie_active(1);						// _Ci~bN\Jn
	delay_ms(1000);									// 1S Delay

	// ŏ̈͒l肵Ȃ̂ŃX[
	for(;;){
		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
			TCNT1 = 0;											// sbmsP@NA
			old_rtc_1s_flg = rtc_1s_flg;
			break;
		}
	}
	for(;;){
		us = get_action_sw();									// XCb`Ԃ
		us &= SW_MASK;											// XCb`ɂ

		if(us == SW1_OFF_LONG){									// XCb`ėꂽ(set switch)
			cli();
			write_eep_bps_600(bps600);							//@ddoqnl BPS_600 
			gBPS1_600 = bps600;
			sei();												// 荞݉
			led_ds2_on();										// LED(DS2) ON
			delay_ms(100);										// 100mS Delay
			led_ds2_off();										// LED(DS2) OFF
		}else if(us == SW1_OFF_SHORT){							// Zꂽ(set switch)
			break;
		}else if(us == SW2_OFF_SHORT){							// Zꂽ(select switch)
			break;
		}

		if(rtc_1s_flg != old_rtc_1s_flg){						// qsbĂ鎞̂Pboߗp
			t1_count = TCNT1;									// sbmsPǂݏo
			TCNT1 = 0;											// sbmsP@NA
			old_rtc_1s_flg = rtc_1s_flg;
			bps600 = calcu_bps600(t1_count);					// ␳aorUOOvZ
			disp_nixie_4binary(2,bps600);						// S\iXXXX܂Łj
			led_ds3_on();										// LED(DS3) ON
			delay_ms(100);										// 100mS Delay
			led_ds3_off();										// LED(DS3) OFF
		}
	}

	timer1_close();												// Timer1 close

}

//*****************************************
//@ddoqnl change_PATH ǂݍ
//*****************************************
unsigned char	read_eep_change_path(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_change_path);		// Ǐo
	if((0 <= eep_bfs[0])&&(eep_bfs[0] <= 9)){
		r = eep_bfs[0];
	}else{
		r = 9;
	}

	return(r);
}

//*****************************************
//@ddoqnl change_PATH 
//*****************************************
static
void	write_eep_change_path(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_change_path, eep_bfs[0]);		// 
	eeprom_busy_wait();
}

//*****************************************
//@ddoqnlchange_PATHҏW
//*****************************************
static
void	edit_eep_change_path(void)
{
	unsigned short	us;
	unsigned char	pt;
	unsigned char	blk_stat = 0;
	unsigned char	blink_time = 30;					// uNԊu

	pt = change_path;
	disp_dynamic_nixie_number(0, 15);
	disp_dynamic_nixie_number(1, 15);
	disp_dynamic_nixie_number(2, 15);
	disp_dynamic_nixie_number(3, pt);
	disp_dynamic_nixie_number(4, 0);
	disp_dynamic_nixie_number(5, 0);

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();									// XCb`Ԃ
		us = us & SW_MASK;										// XCb`ɂ

		if(tim_10ms_blink == 0){								// _Ń^C~O̎
			tim_10ms_blink = blink_time;
			if((blk_stat==0)&&((us & SW2_ON) == 0)&&((us & SW1_ON) == 0)){			// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_dynamic_nixie_number(3, 15);
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(3, pt);
			}
		}

		if(us != 0){											// EANVL鎞
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_OFF_SHORT) != 0)){	// ꑱAZꂽ(select switch)

				if(9 <= pt){
					pt = 0;
				}else{
					pt++;
				}
				disp_dynamic_nixie_number(3, pt);				// l̂P\
				tim_10ms_blink = blink_time;					// uNԊu
			}else if((us & SW1_OFF_LONG) != 0){					// Aꎞ(set switch)
				cli();
				change_path = pt;
				write_eep_change_path(change_path);				// ddoqnl change_PATH ɏ
				led_ds2_on();									// LED(DS2) ON
				delay_ms(100);									// 100mS Delay
				led_ds2_off();									// LED(DS2) OFF
				sei();											// 荞݉
			}else if((us & SW1_OFF_SHORT) != 0){				// ZAꎞ(set switch)
				break;
			}
		}

	}

}


//*****************************************
//@ddoqnl gps_active ǂݍ
//*****************************************
unsigned char	read_eep_gps_active(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_gps_active);		// Ǐo
	if((0 <= eep_bfs[0])&&(eep_bfs[0] <= 1)){
		r = eep_bfs[0];
	}else{
		r = 0;
	}

	return(r);
}

//*****************************************
//@ddoqnl gps_active 
//*****************************************
static
void	write_eep_gps_active(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_gps_active, eep_bfs[0]);		// 
	eeprom_busy_wait();
}

//*****************************************
//@ddoqnl gps_active ҏW
//*****************************************
static
void	edit_eep_gps_active(void)
{
	unsigned short	us;
	unsigned char	pt;
	unsigned char	blk_stat = 0;
	unsigned char	blink_time = 30;					// uNԊu

	pt = gGPS_active;
	if(1 < pt){
		pt = 0;
	}
	disp_dynamic_nixie_number(0, 15);
	disp_dynamic_nixie_number(1, 15);
	disp_dynamic_nixie_number(2, 15);
	disp_dynamic_nixie_number(3, 15);
	disp_dynamic_nixie_number(4, 15);
	disp_dynamic_nixie_number(5, pt);

	tim_10ms_blink = 0;									// _
	while(1){
		us = get_action_sw();									// XCb`Ԃ
		us = us & SW_MASK;										// XCb`ɂ

		if(tim_10ms_blink == 0){								// _Ń^C~O̎
			tim_10ms_blink = blink_time;
			if((blk_stat==0)&&((us & SW2_ON) == 0)&&((us & SW1_ON) == 0)){			// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_dynamic_nixie_number(5, 15);
			}else{
				blk_stat = 0;
				disp_dynamic_nixie_number(5, pt);
			}
		}

		if(us != 0){											// ANVL鎞
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_OFF_SHORT) != 0)){	// ꑱAZꂽ(select switch)

				pt ^= 1;
				disp_dynamic_nixie_number(5, pt);				// l̂P\
				tim_10ms_blink = blink_time;					// uNԊu
			}else if((us & SW1_OFF_LONG) != 0){					// Aꎞ(set switch)
				cli();
				gGPS_active = pt;
				write_eep_gps_active(gGPS_active);				// ddoqnl gGPS_active ɏ
				led_ds2_on();									// LED(DS2) ON
				delay_ms(100);									// 100mS Delay
				led_ds2_off();									// LED(DS2) OFF
				sei();											// 荞݉
			}else if((us & SW1_OFF_SHORT) != 0){				// ZAꎞ(set switch)
				break;
			}
		}

	}

}


//*****************************************
//@ddoqnlDATAҏW
//  iv[v
//*****************************************
void	edit_eep_data(void)
{
	led_ds2_on();									// LED(DS2) ON
	led_ds3_on();									// LED(DS3) ON
	delay_ms(500);									// 500mS Delay
	led_ds2_off();									// LED(DS2) OFF
	led_ds3_off();									// LED(DS3) OFF
	delay_ms(500);									// 500mS Delay
	led_ds2_on();									// LED(DS2) ON
	led_ds3_on();									// LED(DS3) ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_ds2_off();									// LED(DS2) OFF
	led_ds3_off();									// LED(DS3) OFF
	delay_ms(500);									// 500mS Delay
	led_ds2_on();									// LED(DS2) ON
	led_ds3_on();									// LED(DS3) ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_ds2_off();									// LED(DS2) OFF
	led_ds3_off();									// LED(DS3) OFF
	delay_ms(500);									// 500mS Delay
	led_ds3_on();									// LED(DS3) ON
	led_ds2_on();									// LED(DS2) ON
	wait_sw_off();									// XCb`@܂ŉiv[v
	led_ds2_off();									// LED(DS2) OFF
	led_ds3_off();									// LED(DS3) OFF


	while(1){
		edit_bps600();								// aorUOO̒lC

		edit_eep_change_path();						// ddoqnlchange_PATHҏW

		edit_eep_gps_active();						//@ddoqnl gps_active ҏW
	}
}
#endif
