//*******************************************************
//  ATmega48 8x8 dot matrix LED Display
//
//  file name: 8x8main.c
//
//@@@PB1:COL1 High:Active
//@@@PB2:COL2 High:Active
//@@@PC5:COL3 High:Active
//@@@PC4:COL4 High:Active
//@@@PC3:COL5 High:Active
//@@@PC2:COL6 High:Active
//@@@PC1:COL7 High:Active
//@@@PC0:COL8 High:Active
//@@@PB5:DS1(LED1)  Low:OFF, High:ON (ISP MISO)
//@@@PB4:DS2(LED2)  Low:OFF, High:ON (ISP SCK)
//@@@PB3:S1 SET SW Low:Active (ISP MOSI)
//@@@PB0:ROW1 Low:Active
//@@@PD1:ROW2 Low:Active
//@@@PD2:ROW3 Low:Active
//@@@PD3:ROW4 Low:Active
//@@@PD4:ROW5 Low:Active
//@@@PD5:ROW6 Low:Active
//@@@PD6:ROW7 Low:Active
//@@@PD7:ROW8 Low:Active
//@@@PD0:UART RX 600--9600 8N1
//@@@PC6:RESET Low:Active
//
//		ZbgɂcrPƂcrQ_łĂ鎞
//		@ZbgXCb`nmĂƎwԍ̐ݒ胂[hɂȂB
//		E߂Ɏwԍ̐ݒ
//		@݂̎wԍATbԊuœ_łȂ
//		@O`X̐JԂ\Bwԍݒ肵
//		@̐\Ă鎞ɃZbgXCb`
//		@iPbȏjƂkdcP_̂
//		@XCb`𗣂Ɛݒ肳B
//		@ZbgXCb`ZiODTbȉjƎ̐ݒ荀ڂɂȂ
//		EʐM̐ݒ
//		@݂̎w蕶ATbԊuœ_łȂ
//		@f`fAfafAfbfAfcfAfdfAf`fDDDD̏ɕJԂ\B
//		@ʐMaorݒ肵́@̕\Ă鎞ɃZbgXCb`
//		@iPbȏjƂkdc_̂
//		@XCb`𗣂Ɛݒ肳B
//		@ZbgXCb`ZiODTbȉjƎ̐ݒ荀ڂɂȂ
//		E̎f~^R[h̐ݒ
//		@݂̎wR[hATbԊuœ_łȂ
//		@fCRfAfLFfDDDD̏ɕJԂ\B
//		@wԍݒ肵́@̐\Ă鎞ɃZbgXCb`
//		@iPbȏjƂkdc_̂
//		@XCb`𗣂Ɛݒ肳B
//		@ZbgXCb`ZiODTbȉjƎ̐ݒ荀ڂɂȂ
//		@̐ݒ荀ڂ͎wԍɖ߂
//
//
// wԍ̐
//@`rbhhŁ@O@P@Q@R@S@T@U@V@W@X@ƑMꂽ
//@@@@@@@@b@b@b@b@b@b@b@b@b@b
//@@@@@@@@b@b@b@b@b@b@b@b@b@{@O̎wԍŕ\
//@@@@@@@@b@b@b@b@b@b@b@b@{||@P̎wԍŕ\
//@@@@@@@@b@b@b@b@b@b@b@{||||@Q̎wԍŕ\
//@@@@@@@@b@b@b@b@b@b@{||||||@R̎wԍŕ\
//@@@@@@@@b@b@b@b@b@{||||||||@S̎wԍŕ\
//@@@@@@@@b@b@b@b@{||||||||||@T̎wԍŕ\
//@@@@@@@@b@b@b@{||||||||||||@U̎wԍŕ\
//@@@@@@@@b@b@{||||||||||||||@V̎wԍŕ\
//@@@@@@@@b@{||||||||||||||||@W̎wԍŕ\
//@@@@@@@@{||||||||||||||||||@X̎wԍŕ\
//
// w蕶̐iʐMaorj
//		@'A':600BPS				2021/06/23 add 600bps
//		@'B':1200BPS
//		@'C':2400BPS
//		@'D':4800BPS
//		@'E':9600BPS
//
// f~^R[h̐
//		@'LF':0x0a(LF Ctrol-J)
//		@'CR':0x0d(CR Ctrol-M)
//
// ahs[h͖
//
//  2015/02/05  New(TAB4)  Taishi
//  2021/06/23  modify     Taishi add 600bps
//  2022/10/24  modify     taishi for nega48 & Character Mode only, Anode Common only
//*******************************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>


#include	"mega48_8x8_dot.h"
#include	"ofont8x8.h"
#include	"timer.h"
#include	"eep_dat.h"
#include	"uart.h"
#include	"port_bit.h"
#include	"ad_conv.h"




// _Ci~bN_̃Rƍl镨͂qnvP`WƂ
const unsigned char	row_data_PB_off =0b00000001;	// oâqnvf[^neef[^
const unsigned char	row_data_PB[8]={				//  Rォ牺ɓ
									 0b11111111,	//[7]	// ROW8
									 0b11111111,	//[6]	// ROW7
									 0b11111111,	//[5]	// ROW6
									 0b11111111,	//[4]	// ROW5
									 0b11111111,	//[3]	// ROW4
									 0b11111111,	//[2]	// ROW3
									 0b11111111,	//[1]	// ROW2
									 0b11111110,	//[0]	// ROW1
};
const unsigned char	row_data_PD_off =0b01111111;	// oĉqnvf[^neef[^
const unsigned char	row_data_PD[8]={				//  Rォ牺ɓ
									 0b11111110,	//[7]	// ROW8
									 0b11111101,	//[6]	// ROW7
									 0b11111011,	//[5]	// ROW6
									 0b11110111,	//[4]	// ROW5
									 0b11101111,	//[3]	// ROW4
									 0b11011111,	//[2]	// ROW3
									 0b10111111,	//[1]	// ROW2
									 0b11111111,	//[0]	// ROW1
};

const unsigned char	col_data_PB_off =0b11111001;	// oâbnkf[^neef[^
unsigned char	col_data_PB[8]={
									 0b00000010,	//[0]
									 0b00000100,	//[1]
									 0b00000000,	//[2]
									 0b00000000,	//[3]
									 0b00000000,	//[4]
									 0b00000000,	//[5]
									 0b00000000,	//[6]
									 0b00000000,	//[7]
};
							
const unsigned char	col_data_PC_off =0b11000000;	// ob̂bnkf[^neef[^
unsigned char	col_data_PC[8]={
									 0b00000000,	//[0]
									 0b00000000,	//[1]
									 0b00100000,	//[2]
									 0b00010000,	//[3]
									 0b00001000,	//[4]
									 0b00000100,	//[5]
									 0b00000010,	//[6]
									 0b00000001,	//[7]
};
							
// ----- UART ֌W ------
#define	FOSC				_XTAL_FREQ

#define	BIT_RATE600			600									// rbg|g:600 2021/06/23 add 600bps
#define	BIT_RATE1200		1200								// rbg|g:1200
#define	BIT_RATE2400		2400								// rbg|g:2400
#define	BIT_RATE4800		4800								// rbg|g:4800
#define	BIT_RATE9600		9600								// rbg|g:9600


unsigned char	target_number=0;				// Ԗڂ̕\邩̔ԍ(0--9)
unsigned char	bps_character='D';				// ʐMaorw肷镶(A:600 B:1200, C:2400, D:4800, E:9600)
unsigned char	delimiter_cord=0x0d;			// f~^R[h(0x0a or 0x0d)

unsigned char	recieved_data[13];				// VAŎ󂯂f[^

//***************************
// 8x8 dot Dynamic Dispaly
// 1mS Timer ݂ŌĂ΂
//***************************
void	disp_8x8_dot_led(void)
{
	static	unsigned char	count=0;

		PORTB |= row_data_PB_off;		// row off
		PORTD |= row_data_PD_off;		// row off
		PORTB &= col_data_PB_off;		// col off
		PORTC &= col_data_PC_off;		// col off

		PORTB |= col_data_PB[count];	// col set
		PORTC |= col_data_PC[count];	// col set

		PORTB &= row_data_PB[count];	// row set
		PORTD &= row_data_PD[count];	// row set

		count++;
		count &= 0x07;

}

// *****************************
// AXL[hbg}gbNXf[^ɕϊ
//	hbg}gNXf[^́@	col_data[8] ɓ
// *****************************
void	asc_to_dotmatrix(unsigned char uc)
{
	unsigned short	us;
	unsigned char	c;

	us = uc;
	us &= 0x7f;

	c = pgm_read_byte(&font8x8_numchar[us * 8 + 0]);
	c >>= 5;
	col_data_PB[0] = (c & ~col_data_PB_off);

	c = pgm_read_byte(&font8x8_numchar[us * 8 + 1]);
	c >>= 5;
	col_data_PB[1] = (c & ~col_data_PB_off);

	c = pgm_read_byte(&font8x8_numchar[us * 8 + 2]);
	col_data_PC[2] = (c & ~col_data_PC_off);

	c = pgm_read_byte(&font8x8_numchar[us * 8 + 3]);
	col_data_PC[3] = (c & ~col_data_PC_off);

	c = pgm_read_byte(&font8x8_numchar[us * 8 + 4]);
	col_data_PC[4] = (c & ~col_data_PC_off);

	c = pgm_read_byte(&font8x8_numchar[us * 8 + 5]);
	col_data_PC[5] = (c & ~col_data_PC_off);

	c = pgm_read_byte(&font8x8_numchar[us * 8 + 6]);
	col_data_PC[6] = (c & ~col_data_PC_off);

	c = pgm_read_byte(&font8x8_numchar[us * 8 + 7]);
	col_data_PC[7] = (c & ~col_data_PC_off);

}

// *****************************
// \ʒu̐ݒ菈
// *****************************
void	setpro_pos(void)
{
	unsigned char	n;
	unsigned char	blink=0;
	unsigned char	uc;

	tim_10ms_blink = 50;									// 500mS Ԋu
	tim_1s_next = 5;										// 5S Ԋu
	n = target_number;
	asc_to_dotmatrix(n+'0');								// AXL[hbg}gbNXf[^ɕϊ

	while(1){
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;							// 500mS Ԋu
			blink ^= 1;
			if(blink == 0){
				asc_to_dotmatrix(' ');						// AXL[hbg}gbNXf[^ɕϊiXy[Xj
			}else{
				asc_to_dotmatrix(n+'0');					// AXL[hbg}gbNXf[^ɕϊij
			}
		}

		if(tim_1s_next == 0){
			tim_1s_next = 5;								// 5S Ԋu
			//@l̐is
			n++;											//  ̐l
			if(10 <= n){
				n = 0;
			}
			asc_to_dotmatrix(n+'0');						// AXL[hbg}gbNXf[^ɕϊij
			blink = 1;
		}

		uc = get_action_sw();								// XCb`̏
		if(uc & SW1_ON_NOW){								// ꂽ
			led2_on();										// LED ON
		}
		if(uc & SW1_OFF_SHORT){								// Zꂽ
			led2_off();
			break;
		}else if(uc & SW1_OFF_LONG){						// ꂽ
			asc_to_dotmatrix(n+'0');						// AXL[hbg}gbNXf[^ɕϊij
			if(target_number != n){							// ԍύX
				target_number = n;							// ԍ

				cli();
				write_eep_target_no(target_number);			// ddoqnl \Ԗ 
				sei();										// 荞݉
			}
			led1_off();
			break;
		}
	}
}
// *****************************
// ʐMaor̐ݒ菈
// *****************************
void	setpro_bps(void)
{
	unsigned char	n;
	unsigned char	blink=0;
	unsigned char	uc;

	tim_10ms_blink = 50;									// 500mS Ԋu
	tim_1s_next = 5;										// 5S Ԋu
	n = bps_character;
	asc_to_dotmatrix(n);									// AXL[hbg}gbNXf[^ɕϊ

	while(1){
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;							// 500mS Ԋu
			blink ^= 1;
			if(blink == 0){
				asc_to_dotmatrix(' ');						// AXL[hbg}gbNXf[^ɕϊiXy[Xj
			}else{
				asc_to_dotmatrix(n);						// AXL[hbg}gbNXf[^ɕϊij
			}
		}

		if(tim_1s_next == 0){
				tim_1s_next = 5;							// 5S Ԋu
			//@̐is
			n++;											//  ̕
			if('E' < n){
				n = 'A';
			}

			asc_to_dotmatrix(n);							// AXL[hbg}gbNXf[^ɕϊij
			blink = 1;
		}

		uc = get_action_sw();								// XCb`̏
		if(uc & SW1_ON_NOW){								// ꂽ
			led2_on();										// LED ON
		}
		if(uc & SW1_OFF_SHORT){								// Zꂽ
			led2_off();
			break;
		}else if(uc & SW1_OFF_LONG){						// ꂽ
			asc_to_dotmatrix(n);							// AXL[hbg}gbNXf[^ɕϊij
			if(bps_character != n){							// ύX
				bps_character = n;							// 

				cli();
				write_eep_char_bps(bps_character);			// ddoqnl BPS CHAR 
				sei();										// 荞݉

			}
			led2_off();
			break;
		}
	}
}
// *****************************
// f~^iZp[^j̐ݒ菈
// *****************************
void	setpro_delimiter(void)
{
	unsigned char	n;
	unsigned char	blink=0;
	unsigned char	uc;

	tim_10ms_blink = 50;									// 500mS Ԋu
	tim_1s_next = 5;										// 5S Ԋu
	n = delimiter_cord;
	asc_to_dotmatrix(n);									// AXL[hbg}gbNXf[^ɕϊ

	while(1){
		if(tim_10ms_blink == 0){
			tim_10ms_blink = 50;							// 500mS Ԋu
			blink ^= 1;
			if(blink == 0){
				asc_to_dotmatrix(' ');						// AXL[hbg}gbNXf[^ɕϊiXy[Xj
			}else{
				asc_to_dotmatrix(n);						// AXL[hbg}gbNXf[^ɕϊij
			}
		}

		if(tim_1s_next == 0){
			tim_1s_next = 5;								// 5mS Ԋu
			//@R[h̐is
			if(n == 0x0d){									//  ̃R[h
				n = 0x0a;
			}else{
				n = 0x0d;
			}
			asc_to_dotmatrix(n);							// AXL[hbg}gbNXf[^ɕϊij
			blink = 1;
		}

		uc = get_action_sw();								// XCb`̏
		if(uc & SW1_ON_NOW){								// ꂽ
			led2_on();										// LED ON
		}
		if(uc & SW1_OFF_SHORT){								// Zꂽ
			led2_off();
			break;
		}else if(uc & SW1_OFF_LONG){						// ꂽ
			asc_to_dotmatrix(n);							// AXL[hbg}gbNXf[^ɕϊij
			if(delimiter_cord != n){						// ύX
				delimiter_cord = n;							// 

				cli();
				write_eep_delimiter(delimiter_cord);		// ddoqnl ʐMf~^ 
				sei();										// 荞݉

			}
			led2_off();
			break;
		}
	}
}

// *****************************
// ݒ菈
// *****************************
void	setpro(void)
{

	led2_off();
	led1_on();
	sw_init();								// XCb`֌W̏ݒ
	wait_sw_off();							// XCb`܂ő҂
	led1_off();

	asc_to_dotmatrix(' ');					// AXL[hbg}gbNXf[^ɕϊ
	timer2_init();							// Timer2 ݒ
	sei();									// 荞݉

	while(1){
		setpro_pos();						// \ʒu̐ݒ菈
		setpro_bps();						// ʐMaor̐ݒ菈
		setpro_delimiter();					// f~^iZp[^j̐ݒ菈
	}
}

// *****************************
// LN^[h̏
// *****************************
void	proc_char_mode(void)
{
	unsigned char	i;
	unsigned char	uc;
	unsigned char	n;

	for(i=0;i<12;i++){
		recieved_data[i] = ' ';								// VAŎ󂯂f[^NA
	}
	while(1){
		if(uart_rx_one(&uc) == 1){							// ML
			led2_on();										// LED2 ON								// Ԃ𑪂
			for(i=10; 0 < i; i--){
				recieved_data[i] = recieved_data[i-1];		// VAŎ󂯂f[^
			}
			recieved_data[0] = uc;							// VAŎ󂯂f[^𒙂߂
			if(uc == delimiter_cord){						// ̎̏Ԃ͖UQOr
				n = recieved_data[target_number+1];			// VAŎ󂯂f[^̎wԍǂ
				asc_to_dotmatrix(n);						// AXL[hbg}gbNXf[^ɕϊ
				for(i=0;i<12;i++){
					recieved_data[i] = ' ';					// VAŎ󂯂f[^NA
				}
			}
			led2_off();										// LED2 OFF				Ԃ𑪂
		}
	}
}
// *****************************
//	main
// *****************************
int	main(void)
{
	unsigned short	i;
	unsigned char	j;

	MCUCR &= ~(1 << PUD);			// SẴvAbv֎~ɂ͂Ȃ

//				    76543210		//  |[gc
	PORTD	    = 0b00000000;		//	o̓f[^ݒ(SĂO)
	DDRD 		= 0b11111111;		//  o͕ݒ(PD0,1,2,3,4,5,6,7:Output)


//				    76543210		//  |[ga
	PORTB	    = 0b11111111;		//	o̓f[^ݒ
	DDRB 		= 0b11110110;		//  o͕ݒ(PB0,3=)
	PORTB	    = 0b00001001;		//	vAbvݒ(PB0,3=vAbvLARB0&3=1)


//				    76543210		//  |[gb
	PORTC	    = 0b11111111;		//	o̓f[^ݒ(SĂP)
	DDRC 		= 0b11111111;		//  o͕ݒ(PC=Sďo)

	led_dsp_init();					// Port-B Bit2,3 : Output

	delay_ms(100);					// Wait 100mSec


	target_number = read_eep_target_no();				// ddoqnl \Ԗ ǂݍ
	if(9 < target_number){								// ͈͊OisȒlj
		target_number = 0;
		write_eep_target_no(target_number);				// ddoqnl \Ԗ 
	}

	bps_character = read_eep_char_bps();				// ddoqnl BPS CHAR ǂݍ
	if((bps_character < 'A')||('E' < bps_character)){	// ͈͊OisȒlj
		bps_character = 'E';
		write_eep_char_bps(bps_character);				// ddoqnl BPS CHAR 
	}

	delimiter_cord = read_eep_delimiter();				// ddoqnl ʐMf~^ ǂݍ
	if((delimiter_cord != 0x0a)&&(delimiter_cord != 0x0d)){	// ͈͊OisȒlj
		delimiter_cord = 0x0d;
		write_eep_delimiter(delimiter_cord);			// ddoqnl ʐMf~^ 
	}


	for(i=0;i<10;i++){
		led1_toggle();									//  LED1 Toggle
		led2_toggle();									//  LED2 Toggle
		j = (~SW_PORT & (SW1_ON_BIT));
		delay_ms(500);									// Wait 500mSec
		if(j == (~SW_PORT & (SW1_ON_BIT))){
			if(j == 0){									// SET SW:ON
				setpro();								// ݒ菈
			}
		}
	}
	led1_off();											// LED OFF
	led2_off();											// LED OFF

	uart_init();										// UART ݒ

	asc_to_dotmatrix(' ');								// AXL[hbg}gbNXf[^ɕϊiXy[Xj
	timer2_init();										// Timer2 ݒ
	sei();												// 荞݉

	proc_char_mode();									// LN^[h̏

// ȉ`FbNp@KXCȂg
#if	0
	n = 0x00;
	for(;;){
		asc_to_dotmatrix(n);							// AXL[hbg}gbNXf[^ɕϊ
		n++;
		delay_ms(1000);									// Wait 1Sec
	}
#endif

#if	0
	for(;;){
		for(i=0;i<8;i++){
			PORTB |= row_data_RB_off;		// row off
			PORTC |= row_data_RC_off;		// row off
			PORTA &= col_data_off;			// col off
			PORTB &= row_data_RB[i];		// row set
			PORTC &= row_data_RC[i];		// row set
			for(j=0;j<8;j++){
				PORTA &= col_data_off;
				PORTA |= col_data[j];
				delay_ms(250);				// Wait 250mSec
				led1_on();
				led2_off();
				delay_ms(250);				// Wait 250mSec
				led1_off();
				led2_on();
			}
		}
	}
#endif
}
