//*****************************************
// Six IN-17 Clock2 Program ATmega64(64pin)
// CPU Clock:8MHz
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:port_bit.c
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//*****************************************
#include	<avr/io.h>


#include	"mega48_8x8_dot.h"
#include	"timer.h"
#include	"port_bit.h"

static	unsigned char	sw[4];				// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
static	unsigned char	old_sw;
static	unsigned char	sw1_continue_count;

//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
// SW[3] ɗꂽuԂ'1'̏
//  Timer2 ̊荞݂gpĂԂKv
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(tim_10ms_sw == 0){
		tim_10ms_sw = 3;									// ROrԊu
		uc  = ((~SW_PORT) & SW1_ON_BIT);					// ]ăXCb`P̃f[^擾(set switch)
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}

//***************************
//@XCb`֌W̏ݒ
//***************************
void	sw_init(void)
{
	DDRB &= ~((1 << DDB3));		// Port-B Bit3 : Intput
	PORTB |= ((1 << PB3) );		// Port-B Bit3 : Pullup
	sw1_continue_count = 0;
	MCUCR &= ~(1 << PUD);		// SẴvAbv֎~ɂ͂Ȃ

}

#define			TMR_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TMR_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSW?_ON_CONTINUEvɂȂ
#define			TMR_CONTIMUE2		50			// 10mSx50=500mS ꑱ̂Qxڈȍ~́uSW?_ON_CONTINUEvo^C~OɂȂ
//***************************
// XCb`Ԃ߂
//  CĂ΂B
//  {IɃ[v̒̓ĂĂԂƂɂȂ
//  ߂l
//               0: ĂȂB
//    SW?_OFF_LONG; Zėꂽ
//   SW?_OFF_SHORT; ėꂽ
// SW?_ON_CONTINUE; ꑱĂi܂ĂȂj
//
//  Timer2 ̊荞݂gpĂԂKv
//***************************
unsigned char	get_action_sw(void)
{
	unsigned short	us=0;

	get_sw();												// XCb`Ԃ

	// SW-1
	if((sw[2] & SW1_ON_BIT) != 0){							// XCb`Pnm̏uԂ̎(set switch)
		us |= (SW1_ON_NOW | SW1_ON);
		tim_10ms_sw1_continue = TMR_CONTIMUE;
		tim_10ms_sw1_length = TMR_LONG;
		sw1_continue_count = 1;
	}else if((sw[1] & SW1_ON_BIT) != 0){					// XCb`Pnm̎(set switch)
		us |= SW1_ON;
		if(tim_10ms_sw1_continue == 0){						// ꑱo^C~O̎
			us |= SW1_ON_CONTINUE;
			if(sw1_continue_count < 2){
				sw1_continue_count++;
				tim_10ms_sw1_continue = TMR_CONTIMUE;
			}else{
				tim_10ms_sw1_continue = TMR_CONTIMUE2;
			}
		}
	}else if((sw[3] & SW1_ON_BIT) != 0){					// XCb`PꂽuԂ̎(set switch)
		if(tim_10ms_sw1_length == 0){						// ꂽԂ
			us |= SW1_OFF_LONG;
		}else{												// ꂽԂZ
			us |= SW1_OFF_SHORT;
		}
		tim_10ms_sw1_continue = 0;
		tim_10ms_sw1_length = 0;
		sw1_continue_count = 0;
	}else if((sw[1] & SW1_ON_BIT) == 0){					// XCb`Pnee̎(set switch)
		tim_10ms_sw1_continue = 0;
		tim_10ms_sw1_length = 0;
		sw1_continue_count = 0;
	}

	return(us);
}

//*****************************************
// XCb`@܂ŉiv[v
//  XCb`͂Ɋ荞݃^C}[gB
//  Timer2 ̊荞݂gpĂԂKv
//*****************************************
void	wait_key_off(void)
{
	while(1){									// rv܂ő҂
		get_action_sw();						//@XCb`Ԃ
		if( (sw[1] & (SW1_ON_BIT)) == 0 ){		// ꂽ(select switch & set switch)
			break;
		}
	}
}
//*****************************************
// XCb`@܂ŉiv[v
//  XCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//*****************************************
void	wait_sw_off(void)
{
	while(1){
		if((~SW_PORT & (SW1_ON_BIT)) == 0){		// select switch & set switch
			delay_ms(50);						// 50mS Delay
			if((~SW_PORT & (SW1_ON_BIT)) == 0){	// select switch & set switch
				break;							// {ɗꂽƂ
			}
		}
	}
}
